#include <cstdio>
using namespace std;

#include "opencv2/highgui/highgui.hpp"
using namespace cv;

const int FPS = 30;
VideoCapture camera;
Mat inputImage;
Mat savedBackgroundImage;
Mat differenceImage;

void showUsage() {
	printf("Press 'b' to set background\n");
	printf("Press 'k' to terminate\n");
}
 
void processKey(char key) {
	switch(key) {
		case 'b': 
			inputImage.copyTo(savedBackgroundImage);
			imshow("Background",savedBackgroundImage);
			break;
	}
}

int main(int argc, char *argv[]) {
	camera.open(0);
	if(!camera.isOpened()){
		printf("Cannot connect to the camera!\n"); 
		getchar();
	}
	else {
		printf("Connection established!\n");
		showUsage();
		camera.set(CV_CAP_PROP_FRAME_WIDTH,640);
		camera.set(CV_CAP_PROP_FRAME_HEIGHT,480);
		char key=0;
		while(key!='k') {
			camera >> inputImage;
			imshow("Camera Image", inputImage);
			if(savedBackgroundImage.data!=NULL) {
				absdiff(inputImage, savedBackgroundImage,differenceImage);
				imshow("Difference Image",differenceImage);
			}
			key = waitKey(1000/FPS);
			processKey(key);
		}
	}
	return 0;
}